local L = AceLibrary("AceLocale-2.2"):new("Capping")

function Capping:LoadWSGData()
	self.wsgdata = {
		["pickedup"]		= L["The (%w+) .lag was picked up by (.+)!"],
		["dropped"]		= L[".lag was dropped"],
		["captured"]		= L["(.+) captured the (%w+) .lag"],
		[L["Alliance"].."icon"]	= "Interface\\Icons\\INV_Banner_02",
		[L["Horde"].."icon"]		= "Interface\\Icons\\INV_Banner_03",
	}
end

function Capping:StartWSG()
	if not self.wsgdata then
		self:LoadWSGData()
		self:CreateWSGFrame()
	end
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE", "FlagCarrier")
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE", "FlagCarrier")
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL", "WSGStartTimer")
	self:ScheduleRepeatingEvent(RequestBattlefieldScoreData, 3)
end

function Capping:WSGStartTimer()
	self:CheckStartTimer()
end

function Capping:FlagCarrier()
	if string.find(arg1, self.wsgdata.pickedup) then
		local _, _, team, player = string.find(arg1, self.wsgdata.pickedup)

		--Scan the scoreboard to retrieve the carrier's class
		local name, faction, class
		for i=1,20,1 do
			if GetBattlefieldScore(i) and player and string.find(GetBattlefieldScore(i), player) then
				name,_,_,_,_,faction,_,_,class,_,_ = GetBattlefieldScore(i)
       			-- removes the server name
				if string.find(name, "-") then
					name = string.sub(name, 1, string.find(name,"-") - 1)
				end
				break
			end
		end
		if (team == L["Horde"]) and name then
			self.wsgdata.alliancecarrier = name
			TargetAllianceText:SetText("|cff"..self.paint:GetHex( strupper(class) )..name.."|r")
			TargetAlliance:Show()
		elseif name then
			self.wsgdata.hordecarrier = name
			TargetHordeText:SetText("|cff"..self.paint:GetHex( strupper(class) )..name.."|r")
			TargetHorde:Show()
		end

	elseif string.find(arg1, self.wsgdata.dropped) then
		if string.find(arg1, L["Horde"]) then
			self.wsgdata.alliancecarrier = "-"
			TargetAlliance:Hide()
		else
			self.wsgdata.hordecarrier = "-"
			TargetHorde:Hide()
		end
	elseif string.find(arg1, self.wsgdata.captured) then
		self.wsgdata.alliancecarrier = "-"
		self.wsgdata.hordecarrier = "-"

		TargetAlliance:Hide()
		TargetHorde:Hide()
	
		self:StartBar(L["Flag respawns"], 23, self.wsgdata[UnitFactionGroup("player").."icon"], "lightgrey")
	end
end

-- creates the button frames on the scoreboard
function Capping:CreateWSGFrame()
	self.wsgdata.frame1 = CreateFrame("Button", "TargetAlliance", UIParent)
	self.wsgdata.frame1:SetHeight(20)
	self.wsgdata.frame1:SetWidth(130)

	self.wsgdata.frame1:SetPoint("LEFT", AlwaysUpFrame1, "RIGHT", 38, 10)
	self.wsgdata.frame1.text = self.wsgdata.frame1:CreateFontString("TargetAllianceText", "BACKGROUND")
	self.wsgdata.frame1.text:SetFont(GameFontHighlightSmall:GetFont(), 14)
	self.wsgdata.frame1.text:SetJustifyH("LEFT")
	self.wsgdata.frame1.text:SetHeight(20)
	self.wsgdata.frame1.text:SetWidth(130)
	self.wsgdata.frame1.text:ClearAllPoints()
	self.wsgdata.frame1.text:SetAllPoints(self.wsgdata.frame1)
	self.wsgdata.frame1.text:Show()
	
	self.wsgdata.frame2 = CreateFrame("Button", "TargetHorde", UIParent)
	self.wsgdata.frame2:SetHeight(20)
	self.wsgdata.frame2:SetWidth(130)

	self.wsgdata.frame2:SetPoint("LEFT", AlwaysUpFrame2, "RIGHT", 38, 10)
	self.wsgdata.frame2.text = self.wsgdata.frame2:CreateFontString("TargetHordeText", "BACKGROUND")
	self.wsgdata.frame2.text:SetFont(GameFontHighlightSmall:GetFont(), 14)
	self.wsgdata.frame2.text:SetJustifyH("LEFT")
	self.wsgdata.frame2.text:SetHeight(20)
	self.wsgdata.frame2.text:SetWidth(130)
	self.wsgdata.frame2.text:ClearAllPoints()
	self.wsgdata.frame2.text:SetAllPoints(self.wsgdata.frame2)
	self.wsgdata.frame2.text:Show()
	
	self.wsgdata.frame1:Hide()
	self.wsgdata.frame2:Hide()
end
